# Folder Structure

- [Tutorials_DIY](./Tutorials_DIY/): Contains the tutorials with a DIY approach. The tutorials are in a "fill in the blanks" format, where you're expected to fill in the code snippets.
- [Tutorials_Solution](./Tutorials_Solutions/): Contains the tutorials with the complete code solutions.
- [setup](./setup/): Contains the setup instructions for the tutorials.

# Tutorials

Welcome to the exciting world of aiFlows! 🚀 These tutorials are your gateway to mastering the main concepts of aiFlows and the FlowVerse through hands-on examples. To make the most of your learning experience, **we recommend following the tutorials in the given order**. Each tutorial builds on the concepts introduced in the previous one, providing a structured and comprehensive learning path.

Get ready for an engaging journey where you'll build practical skills and gain a deeper understanding of the power and versatility of aiFlows.

Let's dive in and explore the following tutorials !

## 0. Prerequesites
- Go through [setting_up_aiFlows.md](./setting_up_aiflows.md)
- Go through [setup.ipynb](./setup/setup.ipynb)

#### By the Prerequesites's End, I Will Have...
* Installed the aiFlows library successfully
* Established an organized file structure for seamless collaboration within the FlowVerse
* Set up a Hugging Face account for contribution to the FlowVerse (Optional)
* Configured and activated my API keys
* Made sure that all the necessary libraries are installed
* Made sure that I'm able to run the code snippets in the tutorials


## [1. ReverseNumber](./Tutorials_DIY/1.ReverseNumber/ReverseNumber.ipynb)
#### By the Tutorial's End, I Will Have...

- Learned the Flow basics and implement my first Flow
- Understood the basics of Flows engine and served my first Flow
- Learned how to call served Flows
- Learned how to compose Flows into more complex Flows

Link to the solution: [ReverseNumber Solutions](./Tutorials_Solutions/1.ReverseNumber/ReverseNumber.ipynb)

## [2. ChatFlow](./Tutorials_DIY/2.ChatFlow/ChatFlow.ipynb)

#### By the Tutorial's End, I Will Have...

- Learned how to pull a flow from the FlowVerse
- Familiarized myself with a curcial the ChatAtomicFlow
- Learned how to customize existing flows to my needs 

Link to the solution: [ChatFlow Solutions](./Tutorials_Solutions/2.ChatFlow/ChatFlow.ipynb)

## [3. ChatWithGuards](./Tutorials_DIY/3.ChatWithGuards/ChatWithGuards.ipynb)

#### By the Tutorial's End, I Will Have...

- Expanded my knowledge of CompositeFlows and how to use them for more complex tasks
- Have implemeted a chatbot with a prompt injection detector
- Have implemented a chatbot attached to a DB and with a prompt injection detector  

Link to the solution: [ChatWithGuards Solutions](./Tutorials_Solutions/3.ChatWithGuards/ChatWithGuards.ipynb)

## [4. ChatWithInterpreter](./Tutorials_DIY/4.ChatWithInterpreter/ChatWithInterpreter.ipynb)

#### By the Tutorial's End, I Will Have...

- Built a Chatbot connected to a code interpreter able to execute Python code 

Link to the solution: [ChatWithInterpreter Solutions](./Tutorials_Solutions/4.ChatWithInterpreter/ChatWithInterpreter.ipynb)

## [5. Human](./Tutorials_Solutions/5.Human/Human.ipynb)

#### By the Tutorial's End, I Will Have...

- Learned how humans can be represented as Flows
- Learned how Flows can request human input
- Used a simple user interface to chat with Flows
- Learned about dispatch points
- Chated with your neighbor through Flows